//Compile-time parameters
#define TOPC_MAX_SLAVES            1000       //Max. number of slaves

/***********************************************************************
 * TOP-C data types (shared with topc.h)
 */
#ifndef TOPC_TYPES
#define TOPC_TYPES
typedef int TOPC_BOOL;
typedef struct {
  void  *data;
  size_t data_size;
} TOPC_MSG_BUF;
typedef void TOPC_FUNCTION();
struct TOPC_OPT {
       char *name; 
       union { int integer; TOPC_FUNCTION *fnc; } value;
};
#endif

struct opt_list {
  int count;
  struct TOPC_OPT options[20];
};

extern TOPC_MSG_BUF (*COMM_do_task)(void *input); // for comm-seq.c
extern void (*COMM_slave_loop)(void);             // for comm-pthreads.c

void COMM_init(int *argc, char ***argv, struct opt_list *options_list);
void COMM_finalize(void);
TOPC_BOOL COMM_initialized(void);
int COMM_node_count(void);
int COMM_rank(void);
TOPC_BOOL COMM_probe_msg(void);
void COMM_send_msg(void *msg, size_t msg_size, int dst, int tag);
void COMM_receive_msg(void **msg, size_t *msg_size, int *src, int *tag);
void COMM_free_receive_buf(void *msg);
